require "diff-runner/version"
require "diff-runner/invocation"
require "diff-runner/presenter"
require "diff-runner/registary"
require "diff-runner/invocation_runner"

module DiffRunner 
	class App
		def run
			runner.run
			Registary.instance.register(".", runner)
			begin
				sleep
		 	rescue Interrupt
			end
			puts `clear`
			puts "Bye!"
		end

		def invocation
			if not @invocation
				if ARGV.empty?
					$stderr.puts "Please provide a command to run"
					exit(1)
				end

				@invocation = Invocation.new ARGV
			end

			@invocation
		end

		def runner
			@runner ||= InvocationRunner.new invocation, Presenter.new
		end
	end
end


