require 'listen'

module DiffRunner
	class Registary

		def initialize
			@listeners = {}
		end

		@@instance = Registary.new

		def self.instance
			@@instance
		end

		def register(path, action)
			listener = Listen.to(path) do |m, a, d|
				action.run
			end

			listener.start

			@listeners[path] = listener
		end

		def clear 
			@listeners.each do |path, listener|
				listener.stop
			end

			@listeners = {}
		end

		def unregister(path)
			if @listeners.has_key? path
				@listeners.delete(path).stop
			end
		end

		def is_listening?(path)
			@listeners.key? path
		end

		private_class_method :new
	end
end

